//@ts-check

function promise1() {
    return new Promise((resolve => {
        console.log('promise1 started...');
        setTimeout(() => resolve(1), 2000)
    }))  
} 

function promise2() {
    return new Promise((resolve => {
        console.log('promise2 started...');
        setTimeout(() => resolve(2), 1000)
    }))  
}

function promise3() {
    return new Promise((resolve => {
        console.log('promise3 started...');
        setTimeout(() => resolve(3), 3000)
    }))  
} 

/**
 * @param {Array<() => Promise>} arr
 */
function waitAny(arr) {

    const isPromise = (promise) => (typeof promise == 'object') && promise.then

    // Promise.all(arr.map(p => p())).then(r => {console.log(r); })
    // let promises = arr.map((p, i) => p())

    // let promiseInfos = []
    const results = []

    let promiseInfos = arr.map((p, i) => {
        
        let prom = p().then(r => {
            results.push(r)

            const index = promiseInfos.findIndex(p => p == prom);
            if (index !== -1) {
                promiseInfos.splice(index, 1)
            }
            // return promiseInfos[i] = r;
        })

        return prom;
        
        // const curIndex = promiseInfos.length;
        // p().then(r => {            
        //     promiseInfos.push({
        //         result: r
        //     })
        // })
    })

    return {
        i: 0,
        async next() {

            if (this.i == promiseInfos.length) return Promise.resolve(null)
            
            this.i++;

            if (results.length) {
                return results.shift()
            }
            else {
                await Promise['any'](promiseInfos)
                return results.shift()
            }

            // if (arr[this.i]) return arr[this.i++]()
            // if (promiseInfos[this.i]) {
            if (isPromise(promiseInfos[this.i])) {
                await promiseInfos[this.i]                
                return promiseInfos[this.i++];
            }
            else {
                return Promise.resolve(promiseInfos[this.i++])
            }

            
        }
    }
}

let waitingList = waitAny([promise1, promise2, promise3])


async function run() {
    const error = null;

    while (!error) {
        const res = await waitingList.next().catch(er => {
            er = error;
            // console.log(er);
        })
        if (res) console.log(res)
        else {
            break;
        }
    }
}

run()