//@ts-check

function promise1() {
    return new Promise((resolve => {
        console.log('promise1 started...');
        setTimeout(() => resolve(1), 2000)
    }))  
} 

function promise2() {
    return new Promise((resolve => {
        console.log('promise2 started...');
        setTimeout(() => resolve(2), 1000)
    }))  
}

function promise3() {
    return new Promise((resolve => {
        console.log('promise3 started...');
        setTimeout(() => resolve(3), 3000)
    }))  
} 

/**
 * @param {Array<() => Promise>} arr
 */
function waitAny(arr) {

    const results = []

    let promiseInfos = arr.map(asyncAct => {
        
        let prom = asyncAct().then(result => {
            
            results.push(result)

            const index = promiseInfos.findIndex(p => p == prom);
            if (index !== -1) {
                promiseInfos.splice(index, 1)
            }            
        })

        return prom;

    })

    return {
        i: 0,
        async next() {

            if (this.i++ == arr.length) return Promise.resolve(null)                    

            if (results.length) return results.shift()
            else {
                await Promise['any'](promiseInfos)
                return results.shift()
            }
            
        }
    }
}

let waitingList = waitAny([promise1, promise2, promise3])


async function run() {
    
    let error = null;

    while (!error) {
        const res = await waitingList.next().catch(er => {
            error = er;
            console.log(error);
        })
        if (res) console.log(res)
        else {
            break;
        }
    }
}

run()